import hashlib
from datetime import datetime
import random
import time


class Blockchain(object):
    def __init__(self):
        self.chain = []
        self.current_transactions = []

        self.vote = []
        #genesis block 생성
        self.last_block={} #기본 추가
        self.new_block(previous_hash = 1)
        
        
    def new_block(self, previous_hash, nonce=None, difficulty=None, merkleroot=None): # 값 전달해야함
        now = datetime.now()
        t = now.strftime('%Y.%m.%d.%H:%M')
        block = {
            'type' : 'block',
            'index' : len(self.chain) + 1,
            'timestamp' : t,
            'transactions' : self.current_transactions,
            'previous_hash' :previous_hash ,
            'merkleroot' : merkleroot, 
        }

        self.current_transactions = []

        self.chain.append(block)
        self.last_block=block #기본 추가
        return block
    
    def new_transaction(self, number, user, checkpoint, time, pass_fail):
        #now = datetime.now()
        #t = now.strftime('%Y.%m.%d.%H:%M')
        
        self.current_transactions.append({
            'type' : 'transaction',
            'number' : len(self.current_transactions)+1,          #인덱스번호
            'user': user,               #user = 출입자
            'checkpoint' : checkpoint,  #checkpoint = 보안장치(문)
            'time' : time,              #time = 출입시도 시각
            'pass_fail' : pass_fail,    #pass_fail = 출입여부
        })

        return self.last_block['index'] + 1

    
    
    def hash(block): # 이함수 전체적 오류 이상함 다이상함 질문
        block_string = json.dumps(block, sort_keys = True).encode()
        return hashlib.sha256(block_string).hexdigest


    #self.chain = []
    def hash_block(self): #해시 함수
        sha = hashlib.sha256()
        hash_string = (str(self.chain[-1]['index'])+str(self.chain[-1]['timestamp'])
                       +str(self.chain[-1]['transactions'])+str(self.chain[-1]['previous_hash'])
                       +str(self.chain[-1]['merkleroot']))
        sha.update(hash_string.encode())
        return sha.hexdigest()



    def input_transaction(self,dic): #트랜잭션 함수에 값 넘겨주기
        del dic['type']
        self.new_transaction(dic['number'], dic['user'], dic['checkpoint'],dic['time'], dic['pass_fail'])        
    

    def last_block(self):
        return self.chain[-1]

    def last_tran(self):
        return self.current_transactions[-1]
    
    def print_transaction(self):
        print(self.chain[1]['transactions'][0]['user']) #형식

    def print_block(self,start_point = -1, finish_point = 0):
        if start_point == -1:
            print("블록번호 : "+str(self.last_block['index'])+
                  "\n발생시간 : "+str(self.last_block['timestamp'])+
                  "\n이전해쉬 : "+str(self.last_block['previous_hash'])+
                  "\n현재해쉬 : "+str(self.hash_block())+
                  "\n머클루트 : "+str(self.last_block['merkleroot']))
            self.print_transaction(self.last_block['transactions'],self.last_block['index'])
        elif start_point > -1 and finish_point == 0:
            print("블록번호 : "+str(self.chain[start_point]['index'])+
                  "\n발생시간 : "+str(self.chain[start_point]['timestamp'])+
                  "\n이전해쉬 : "+str(self.chain[start_point]['previous_hash'])+
                  "\n현재해쉬 : "+str(self.hash_block())+
                  "\n머클루트 : "+str(self.chain[start_point]['merkleroot']))
            self.print_transaction(self.chain[start_point]['transactions'],start_point)
        elif start_point > -1 and finish_point > -1:
            for i in range(start_point, finish_point):
                print("블록번호 : "+str(self.chain[i]['index'])+
                      "\n발생시간 : "+str(self.chain[i]['timestamp'])+
                      "\n이전해쉬 : "+str(self.chain[i]['previous_hash'])+
                      "\n현재해쉬 : "+str(self.hash_block())+
                      "\n머클루트 : "+str(self.chain[i]['merkleroot']))
                self.print_transaction(self.chain[i]['transactions'],i)
                print("\n\n\n")

                
    def print_transaction(self,transaction,index):
        if len(transaction)!=0 and index!=0:
            print("============="+str(index+1)+"번 블록의 트랜잭션 시작=============\n")
            for i in range(len(transaction)):
                print("트랜잭션번호 : "+str(transaction[i]['number'])+
                      "\n발생시간 : "+str(transaction[i]['time'])+
                      "\n출입자 : "+str(transaction[i]['user'])+
                      "\n체크포인트 : "+str(transaction[i]['checkpoint'])+
                      "\n개폐여부 : "+str(transaction[i]['pass_fail'])+"\n")
            print("============="+str(index+1)+"번 블록의 트랜잭션 끝=============\n")
        else:
            print("트랜잭션 : None")

    def new_user(self):
        pass


    def vote_block(self, vote,userinfo): #합의
         agree = 0
         for k in range(10):
            for i in range(5):
                i = random.randrange(0,2)
                vote.append(i)
            print(vote)
            for j in range(5):
                if vote[j] ==1:
                    agree +=1
            if agree >= (len(vote)*0.51):
                userinfo['pass_fail'] = "PASS"
                self.input_transaction(userinfo)
                self.new_block(self.hash_block(),2,3,4)
                self.print_block()
                print("블록생성 성공")
            else:
                userinfo['pass_fail'] = "FAIL"
                self.input_transaction(userinfo)
                print("블록생성 실패")
            vote = [0]*0
            agree = 0
            time.sleep(1)


            
#block=Blockchain()

#userinfo = {'number' : 1, 'user' : "kim minjeong", 'checkpoint' : 3, 'time' : datetime.datetime.now(), 'pass_fail' : "PASS"}
#block.input_transaction(userinfo)

#block.new_block(1,2,3,4)

    
#block.vote_block(block.vote,userinfo)



#def hash_block(self): #해시 함수
#hash_block()


#block.new_transaction(1,"lee",3,time(),"pass")
#block.new_transaction(2,"2lee",3,time(),"pass")
#block.new_transaction(3,"l3ee",3,time(),"pass")
#block.new_transaction(3,"l3ee",3,time(),"pass")


