import face_recognition
import cv2
import numpy as np
import os
import sys
import time
import logging
from datetime import datetime 
from watchdog.observers import Observer
from watchdog.events import FileSystemEventHandler
from socket import *
import threading
import time
import json
import random
import hashlib
import pickle
import sys
from PyQt5 import QtCore, QtGui, QtWidgets


video_capture = cv2.VideoCapture(0)



class Ui_Main_F(object):
    def setupUi(self, Main_F):
        Main_F.setObjectName("Main_F")
        Main_F.resize(969, 678)
        Main_F.setStyleSheet("background-color: rgb(255,254,239);")
        Main_F.setSizeGripEnabled(False)
        self.label = QtWidgets.QLabel(Main_F)
        self.label.setGeometry(QtCore.QRect(0, 0, 969, 51))
        font = QtGui.QFont()
        font.setFamily("맑은 고딕")
        font.setPointSize(16)
        font.setBold(True)
        font.setWeight(75)
        self.label.setFont(font)
        self.label.setStyleSheet("background-color: rgb(170, 0, 0);")
        self.label.setFrameShape(QtWidgets.QFrame.NoFrame)
        self.label.setObjectName("label")
        self.plainTextEdit = QtWidgets.QPlainTextEdit(Main_F)
        self.plainTextEdit.setGeometry(QtCore.QRect(30, 130, 901, 501))
        font = QtGui.QFont()
        font.setFamily("맑은 고딕")
        font.setPointSize(14)
        self.plainTextEdit.setFont(font)
        self.plainTextEdit.setFocusPolicy(QtCore.Qt.NoFocus)
        self.plainTextEdit.setStyleSheet("background-color: rgb(255, 255, 255);\n"
"border: 3px solid #002060;")
        self.plainTextEdit.setReadOnly(True)
        self.plainTextEdit.setObjectName("plainTextEdit")

        self.retranslateUi(Main_F)
        QtCore.QMetaObject.connectSlotsByName(Main_F)

    def retranslateUi(self, Main_F):
        _translate = QtCore.QCoreApplication.translate
        Main_F.setWindowTitle(_translate("Main_F", "GUI FACE"))
        Main_F.setToolTip(_translate("Main_F", "<html><head/><body><p>hi</p><p><br/></p></body></html>"))
        Main_F.setWhatsThis(_translate("Main_F", "<html><head/><body><p>h</p></body></html>"))
        self.label.setText(_translate("Main_F", "<html><head/><body><p align=\"center\"><span style=\" color:#ffffff;\">Well-made</span></p></body></html>"))
        self.plainTextEdit.setPlainText(_translate("Main_F", "Face"))

    def settext(self, str_):
        self.plainTextEdit.appendPlainText(str_)

app = QtWidgets.QApplication(sys.argv)
Main_F = QtWidgets.QDialog()
ui = Ui_Main_F()
ui.setupUi(Main_F)
Main_F.show()


class Node():
    def __init__(self, host, port):
        self.host = host
        self.port = int(port)
        self.nodes = []

    def __debug(self, msg):
        ui.settext('[%s] %s' % (str(threading.currentThread().getName()), msg))

    def __debug_server(self,msg):
        ui.settext('[얼굴인식서버] %s\n' %(msg))

    def __debug_client(self, msg):
        th_name = str(threading.currentThread().getName())
        if th_name =='MainThread':
            ui.settext('[출입문-얼굴인식서버 연결] %s\n' %(msg))
        else:
            ui.settext('[얼굴인식서버] %s\n' %(msg))

    def scanning(self, s):  # 얼굴 인식
        self.__send(s, {'type':'face', 'data':result_value})
        self.__debug_client('생체정보 전송완료\n')
        time.sleep(1)

    def new_user(self, s):
        self.__send(s, {'type':'new_face', 'data':new_name})
        self.__debug_client('새로운 사용자 정보 전송완료 \n')
        time.sleep(1)

    def run_server(self):
        self.s = socket(AF_INET, SOCK_STREAM)
        self.s.bind((self.host, self.port))
        self.s.listen(5)

        self.__debug_server('서버 실행 (%d)\n' % self.port)
        #time.sleep(10)

        while True:
            self.__debug_server('연결대기 ... ')
            client_sock, client_addr = self.s.accept()
            self.nodes.append(client_sock)
            self.__debug_server('연결됨' + str(self.nodes[-1].getpeername()))

            t_recv = threading.Thread(target = self.__recv, args={self.nodes[-1]})
            t_recv.start()

    def run_client(self, host, port):   # run_client(host, port) -> 소켓 연결
        s = socket(AF_INET, SOCK_STREAM)
        s.connect((host, int(port)))
        self.__debug_client('연결됨 ' + str(s.getpeername()))
        return s

    def __send(self, s, data):  # __send(socket, data) -> 데이터 전송
        #msg = json.dumps(data, separators=(',', ':')).encode('utf-8')
        msg = pickle.dumps(data)
        s.sendall(msg)

    def recv(self, s):
        self.__debug_client('연결완료. 데이터 수신 대기중 ... \n')
        while True:
            msg = s.recv(1024)
            data = pickle.loads(msg)
            #data = json.loads(msg)
            if data:
                self.__debug_client('받은정보 : ' + str(data))
                if(data.get('type') == 'r_face'):
                    ui.settext(str(data))



class Handler(FileSystemEventHandler):
    def on_created(self, event):
        global new_name
        now = datetime.now()
        ui.settext("\n training에 새로운 사용자가 추가되었습니다.",'[%s-%s-%s-%s:%s:%s]\n'
              % (now.year, now.month, now.day, now.hour, now.minute, now.second))
        images_name = os.listdir(path_dir)
        names = "".join(map(str, images_name)).split(".jpg")
        del names[len(names)-1]

        for new_name in names :
            if new_name not in known_face_names:
                known_face_names.append(new_name)
                image_load = face_recognition.load_image_file(path_dir + "\\" + new_name + ".jpg")
                encoding = face_recognition.face_encodings(image_load)[0]
                known_face_encodings.append(encoding)
                new_send = threading.Thread(target = face.new_user, args={face_c})
                new_send.start()


path_dir = r'C:\Users\lee\Desktop\training'
images_name = os.listdir(path_dir)
names = "".join(map(str, images_name)).split(".jpg")
del names[len(names)-1]
    
known_face_encodings = []
known_face_names = []

for image in images_name:
    image_load = face_recognition.load_image_file(path_dir +"\\" + image)
    face_encoding = face_recognition.face_encodings(image_load)[0]
    known_face_encodings.append(face_encoding)
    known_face_names.append((image.split("."))[0])


# 변수 초기화
class Face():
    global result_value
    global face_c
    global face
    
    face_locations = []
    face_encodings = []
    face_names = []
    process_this_frame = True
 
   
    while True:
        ret, frame = video_capture.read()
        small_frame = cv2.resize(frame, (0, 0), fx=0.25, fy=0.25)
        rgb_small_frame = small_frame[:, :, ::-1]
        
        if process_this_frame:
           
            face_locations = face_recognition.face_locations(rgb_small_frame)
            face_encodings = face_recognition.face_encodings(rgb_small_frame, face_locations)
            face_names = []
            
            for face_encoding in face_encodings:
                face_distances = face_recognition.face_distance(known_face_encodings, face_encoding)
                min_value = min(face_distances)
                name = "Unknown"
                now = datetime.now()
     
                if min_value < 0.435: 
                    index = np.argmin(face_distances)
                    name = known_face_names[index]
                    value = "True"
                    ui.settext("등록된 사용자 입니다. [True]")
                else :
                    value = "False"
                    ui.settext("등록되지 않은 사용자 입니다. [False]")                
                day = (name,value,
                      '%s-%s-%s-%s:%s:%s' % (now.year, now.month, now.day, now.hour, now.minute, now.second))
                result_value=[day]               
                face_names.append(name)
               
                ui.settext("Face Recognition")
                host = 'localhost'
                port = int(2345)
                face =Node(host,port)
                face_c = face.run_client('localhost', 1234)
                f_recv = threading.Thread(target =face.recv, args = {face_c})
                f_recv.start()
                f_scanning = threading.Thread(target=face.scanning, args = {face_c})
                f_scanning.start()
                         
        process_this_frame = not process_this_frame
        
        event_handler = Handler()
        observer = Observer()
        observer.schedule(event_handler, path_dir, recursive=True)
        observer.start()
        time.sleep(1)
        observer.stop()
        
        for (top, right, bottom, left), name in zip(face_locations, face_names):
            top *= 4
            right *= 4
            bottom *= 4
            left *= 4

            cv2.rectangle(frame, (left, top), (right, bottom), (0, 0, 255), 2)
            cv2.rectangle(frame, (left, bottom - 35), (right, bottom), (0, 0, 255), cv2.FILLED)
            font = cv2.FONT_HERSHEY_DUPLEX
            cv2.putText(frame, name, (left + 6, bottom - 6), font, 1.0, (255, 255, 255), 1)

        cv2.imshow('Video', frame)

        if cv2.waitKey(1) & 0xFF == ord('q'):
            break
                    
    video_capture.release()
    cv2.destroyAllWindows()

thrd = threading.Thread(target = Face, args={})
thrd.start()
app.exec_()
