import time
from datetime import datetime
import json
import random
import hashlib
import threading
import pickle
import copy
from socket import *
from bc import Blockchain
import os 

import sys
from PyQt5 import QtCore, QtGui, QtWidgets

f1=""


class Ui_Main_F(object):
    def setupUi(self, Main_F):
        Main_F.setObjectName("Main_F")
        Main_F.resize(969, 678)
        Main_F.setStyleSheet("background-color: rgb(255,254,239);")
        Main_F.setSizeGripEnabled(False)
        self.label = QtWidgets.QLabel(Main_F)
        self.label.setGeometry(QtCore.QRect(0, 0, 969, 51))
        font = QtGui.QFont()
        font.setFamily("맑은 고딕")
        font.setPointSize(16)
        font.setBold(True)
        font.setWeight(75)
        self.label.setFont(font)
        self.label.setStyleSheet("background-color: rgb(170, 0, 0);")
        self.label.setFrameShape(QtWidgets.QFrame.NoFrame)
        self.label.setObjectName("label")
        self.plainTextEdit = QtWidgets.QPlainTextEdit(Main_F)
        self.plainTextEdit.setGeometry(QtCore.QRect(30, 130, 901, 501))
        font = QtGui.QFont()
        font.setFamily("맑은 고딕")
        font.setPointSize(14)
        self.plainTextEdit.setFont(font)
        self.plainTextEdit.setFocusPolicy(QtCore.Qt.NoFocus)
        self.plainTextEdit.setStyleSheet("background-color: rgb(255, 255, 255);\n"
"border: 3px solid #002060;")
        self.plainTextEdit.setReadOnly(True)
        self.plainTextEdit.setObjectName("plainTextEdit")

        self.retranslateUi(Main_F)
        QtCore.QMetaObject.connectSlotsByName(Main_F)

    def retranslateUi(self, Main_F):
        _translate = QtCore.QCoreApplication.translate
        Main_F.setWindowTitle(_translate("Main_F", "GUI ICA1"))
        Main_F.setToolTip(_translate("Main_F", "<html><head/><body><p>hi</p><p><br/></p></body></html>"))
        Main_F.setWhatsThis(_translate("Main_F", "<html><head/><body><p>h</p></body></html>"))
        self.label.setText(_translate("Main_F", "<html><head/><body><p align=\"center\"><span style=\" color:#ffffff;\">Well-made</span></p></body></html>"))
        self.plainTextEdit.setPlainText(_translate("Main_F", "ICA1"))

    def settext(self, str_):
        self.plainTextEdit.appendPlainText(str_)

app = QtWidgets.QApplication(sys.argv)
Main_F = QtWidgets.QDialog()
ui = Ui_Main_F()
ui.setupUi(Main_F)
Main_F.show()


class Node():
    def __init__(self, host, port):
        self.host = host
        self.port = int(port)
        self.nodes = []

    def __debug(self, msg):
        #global ui
        ui.settext('[%s] %s' % (str(threading.currentThread().getName()), msg))

    def __debug_server(self, msg):
        ui.settext('[첫번째 중간인증기관 서버] %s' %(msg))

    def __debug_client(self, msg):
        th_name = str(threading.currentThread().getName())
        if th_name =='Thread-2':
            ui.settext('[첫번째 중간인증기관 서버] %s\n' %(msg))
        else:
            ui.settext('[첫번째 중간인증기관 서버] %s\n' %(msg))

    def run_server(self):
        self.s = socket(AF_INET, SOCK_STREAM)
        self.s.bind((self.host, self.port))
        self.s.listen(5)

        self.__debug_server('서버 실행 (%d)\n' % self.port)
        #time.sleep(10)
        recv_count = 0
        while True:
            self.__debug_server('연결대기 ... ')
            client_sock, client_addr = self.s.accept()
            self.nodes.append(client_sock)
            self.__debug_server('연결됨' + str(self.nodes[-1].getpeername()))

            t_recv = threading.Thread(target = self.recv_data, args={self.nodes[-1]})
            t_recv.start()
            recv_count+=1
            
    def run_client(self, host, port):
        s = socket(AF_INET, SOCK_STREAM)
        s.connect((host, int(port)))
        #self.__debug_client('연결됨' + str(s.getpeername()))
        ui.settext('[첫번째 인증기관 서버-출입문 연결] 연결됨'+str(s.getpeername()))
        return s

    def __send(self, s, data):
        # msg = json.dumps(data, separators=(',', ':')).encode('utf-8')
        #msg = json.dumps(data).encode('utf-8')
        #msg = json.dumps(data)
        msg = pickle.dumps(data)
        s.sendall(msg)
        #self.__debug('send : ' + str(msg))


    def send_block(self, s):
        i = 4
        time.sleep(30)
        time.sleep(30)
        time.sleep(30)
        while True:
            blocks = block.new_block(block.hash_block(),2,3,i)
            self.__send(s, blocks)
            i += 1
           #self.__debug_client('생성된 블록을 중앙인증기관(CA)으로 전송\n')
            ui.settext('[첫번째 인증기관 서버] 생성된 블록을 중앙인증기관(CA)으로 전송\n')
            time.sleep(5)


    def sign(self,s):
        time.sleep(10)
        self.__send(s, {'type':'verify' ,'cp_name':self.cp_name, 'cp_sign':self.cp_sign})
        
                    
    def recv_data(self, s):
        global ui 
        #self.__debug_client('데이터 수신 대기중 ... ')
        ui.settext('[첫번째 중간인증기관 서버] 데이터 수신 대기중 ... ')
        while True:
            global block
            #global ui        
            global ca_conn
            #global name
            global names
            msg = s.recv(1024)
            data = pickle.loads(msg)
            #data = json.loads(msg)
            
            if data:
                #self.__debug_client('받은정보 : ' + str(data))
                
                if(data.get('type') == 'transaction'):
                    ui.settext('[출입문 수신] 트랜잭션 수신 완료')
                    block.input_transaction(data) ##트랜잭션 쌓기 
                    tranNsign = copy.deepcopy(data) # cp에서 보낸 트랜잭션에 인증서 추가
                    tranNsign.update({'type':'tranNsign', 'cp_name':self.cp_name, 'cp_sign':self.cp_sign})
                    #global ui
                    ui.settext('[첫번째 인증기관 서버] 서명 검증을 위한 서명 전송.')
                    ui.settext("\n"+str(tranNsign))
                    # type을 tranNsing으로 교체 - ica가 cp에서 온 트랜잭션인지 ca에서 온 트랜잭션인지 구분을 위해
                    #self.__debug_client("서명 검증을 위한 서명 전송.")

                    self.__send(ca_conn, tranNsign)

                    
                elif(data.get('type') == 'tranNsign'):
                    data.updata({'type':'transaction'})
                    block.input_transaction(data)
                    


                elif(data.get('type') == 'face'):
                    name = data.get('data')
                    n1 = name.replace("[('","")
                    n2 = n1.replace("'","")
                  
                    if(n2 in names):
                        passfail = data.get('passfail')
                        #self.__send(s, {'type':'passfail', 'user':"민정", 'passfail':"ㅁ"})
                        self.__send(s, {'type':'passfail', 'user':n2, 'passfail':passfail})

                    else:
                        self.__send(s, {'type':'passfail', 'user':'unknown', 'passfail':"False"})

                elif(data.get('type') == 'new_name'):
                    names.append(data.get('data'))
                    
                elif(data.get('type') == 'sign_copy'):
                    self.cp_name = data.get('cp_name')
                    self.cp_sign = data.get('cp_sign')

                elif(data.get('type') == 'vote'):
                    verify = data.get('data')
                    
                    if (verify==True): #ICA 검증 과정      
                        self.__send(s, {'type':'r_vote', 'data':1})# 찬성
                        ui.settext("생성된 블록에 대한 검증완료")
                    else:
                        ui.settext(verify)
                        self.__send(s, {'type':'r_vote', 'data':0})# 반대 


                elif(data.get('type') =='block'):
                    ui.settext("블록 수신 완료")
                    
names=""
global ca_conn
def hi():
    global ui
    global block
    global checkpoint
    global names
    global ca_conn

    host = 'localhost'
    port = int(2000)
    block = Blockchain()
    block.new_block(1,1,1,1)
    com = 1     # 얼굴 비교 값 (임시)

    #path_dir = r'C:\Users\lee\Desktop\training'
    #images_name = os.listdir(path_dir)
    #names = "".join(map(str, images_name)).split(".jpg")
    #del names[len(names)-1]            

    ica = Node(host, port)

    ca_conn = ica.run_client(host, int(3000))
    ca_recv = threading.Thread(target = ica.recv_data, args={ca_conn})
    ca_recv.start()
    start_time = time.time()
    ca_vote = threading.Thread(target = ica.send_block, args={ca_conn})                                   
    ca_vote.start()

    ica.run_server()


checkpoint =""

block = Blockchain() 
thrd = threading.Thread(target = hi, args={})
thrd.start()
app.exec_()

