import time
from datetime import datetime
import json
import random
import hashlib
import threading
import pickle
import copy
from socket import *
from bc import Blockchain
import os 

import sys
from PyQt5 import QtCore, QtGui, QtWidgets

f1=""


class Ui_Main_F(object):
    def setupUi(self, Main_F):
        Main_F.setObjectName("Main_F")
        Main_F.resize(969, 678)
        Main_F.setStyleSheet("background-color: rgb(255,254,239);")
        Main_F.setSizeGripEnabled(False)
        self.label = QtWidgets.QLabel(Main_F)
        self.label.setGeometry(QtCore.QRect(0, 0, 969, 51))
        font = QtGui.QFont()
        font.setFamily("맑은 고딕")
        font.setPointSize(14)
        font.setBold(True)
        font.setWeight(75)
        self.label.setFont(font)
        self.label.setStyleSheet("background-color: rgb(170, 0, 0);")
        self.label.setFrameShape(QtWidgets.QFrame.NoFrame)
        self.label.setObjectName("label")
        self.plainTextEdit = QtWidgets.QPlainTextEdit(Main_F)
        self.plainTextEdit.setGeometry(QtCore.QRect(30, 130, 901, 501))
        font = QtGui.QFont()
        font.setFamily("맑은 고딕")
        font.setPointSize(14)
        self.plainTextEdit.setFont(font)
        self.plainTextEdit.setFocusPolicy(QtCore.Qt.NoFocus)
        self.plainTextEdit.setStyleSheet("background-color: rgb(255, 255, 255);\n"
"border: 3px solid #002060;")
        self.plainTextEdit.setReadOnly(True)
        self.plainTextEdit.setObjectName("plainTextEdit")

        self.retranslateUi(Main_F)
        QtCore.QMetaObject.connectSlotsByName(Main_F)

    def retranslateUi(self, Main_F):
        _translate = QtCore.QCoreApplication.translate
        Main_F.setWindowTitle(_translate("Main_F", "GUI Test"))
        Main_F.setToolTip(_translate("Main_F", "<html><head/><body><p>hi</p><p><br/></p></body></html>"))
        Main_F.setWhatsThis(_translate("Main_F", "<html><head/><body><p>h</p></body></html>"))
        self.label.setText(_translate("Main_F", "<html><head/><body><p align=\"center\"><span style=\" color:#ffffff;\">중부대학교</span></p></body></html>"))
        self.plainTextEdit.setPlainText(_translate("Main_F", "ICA3"))

    def settext(self, str_):
        self.plainTextEdit.appendPlainText(str_)

app = QtWidgets.QApplication(sys.argv)
Main_F = QtWidgets.QDialog()
ui = Ui_Main_F()
ui.setupUi(Main_F)
Main_F.show()


class Node():
    def __init__(self, host, port):
        self.host = host
        self.port = int(port)
        self.nodes = []

    def __debug(self, msg):
        print('[%s] %s' % (str(threading.currentThread().getName()), msg))

    def __debug_server(self,msg):
        global ui
        ui.settext('[세번째 중간인증기관 서버] %s' %(msg))

    def __debug_client(self, msg):
        th_name = str(threading.currentThread().getName())
        if th_name =='Thread-1':
            ui.settext('[세번째 중간인증기관(ICA3)-인증기관(CA) 연결] %s\n' %(msg))
        elif th_name =='Thread-2':
            ui.settext('[인증기관(CA) 수신] %s\n' %(msg))
        else:
            ui.settext('[세번째 중간인증기관 서버] %s\n' %(msg))
       # print('[%s] %s' % (str(threading.currentThread().getName()), msg))



    def run_server(self):
        self.s = socket(AF_INET, SOCK_STREAM)
        self.s.bind((self.host, self.port))
        self.s.listen(5)

       # self.__debug_server('서버 실행 (%d)' % self.port)
        #time.sleep(10)

        while True:
            #self.__debug_server('연결대기 ... ')
            client_sock, client_addr = self.s.accept()
            self.nodes.append(client_sock)
            self.__debug_server('연결됨' + str(self.nodes[-1].getpeername()))

            t_recv = threading.Thread(target = self.recv_data, args={self.nodes[-1]})
            t_recv.start()

    def run_client(self, host, port):
        s = socket(AF_INET, SOCK_STREAM)
        s.connect((host, int(port)))
        ui.settext('[세번째 중간인증기관 서버(ICA3)-인증기관(CA)] 연결됨'+str(s.getpeername())+"\n")
        return s

    def __send(self, s, data):
        #msg = json.dumps(data, separators=(',', ':')).encode('utf-8')
        msg = pickle.dumps(data)
        s.sendall(msg)
        #self.__debug('send : ' + str(msg))


    def recv_data(self, s):
        #self.__debug_client('연결완료. 데이터 수신 대기중 ... ')
        ui.settext('[세번째 중간인증기관 서버] 데이터 수신 대기중 ... \n')

        while True:
            #global name
            msg = s.recv(1024)
            data = pickle.loads(msg)
            #data = json.loads(msg)

            if data:
             #   self.__debug_client('받은정보 : ' + str(data))
                if(data.get('type') == 'transaction'):
                    ui.settext('[인증기관 수신(CA)] 트랜잭션 수신 완료')
                    self.__send(s, {'type':'msg', 'data':'Receive tran'})
                    self.__send(ca_conn, data)

                elif(data.get('type') == 'face'):
                    if(name == data.get('data')):
                        self.__send(s, {'type':'passfail', 'user':name, 'passfail':1})
                    else:
                        self.__send(s, {'type':'passfail', 'user':'unknown', 'passfail':0})
                    
                elif(data.get('type') == 'sign'):
                    pass

                elif(data.get('type') == 'sign_copy'):
                    ui.settext('[인증기관 수신(CA)] 서명 수신 완료\n' +str(data)+"\n")
                    self.cp_name = data.get('cp_name')
                    self.cp_sign = data.get('cp_sign')
             

                elif(data.get('type') == 'vote'):
                    verify = data.get('data')
                    if (verify==True): #ICA 검증 과정      
                        self.__send(s, {'type':'r_vote', 'data':1})# 찬성
                        ui.settext('[세번째 인증기관 서버] 블록합의에 대한 동의 전송\n')
                    else:
                        ui.settext(verify)
                        self.__send(s, {'type':'r_vote', 'data':0})# 반대
                        
                elif(data.get('type') =='block'):
                    i.settext("[세번째 인증기관 서버] 블록 수신 완료\n")
            

            
global ca_conn
def hi():
    global ui
    global block
    global checkpoint
    global names
    global ca_conn

    host = 'localhost'
    port = int(2003)
    block = Blockchain()
    block.new_block(1,1,1,1)
    com = 1     # 얼굴 비교 값 (임시)

    #path_dir = r'C:\Users\lee\Desktop\training'
    #images_name = os.listdir(path_dir)
    #names = "".join(map(str, images_name)).split(".jpg")
    #del names[len(names)-1]            

    ica = Node(host, port)

    ca_conn = ica.run_client(host, int(3000))
    ca_recv = threading.Thread(target = ica.recv_data, args={ca_conn})
    ca_recv.start()
    start_time = time.time()
   

    ica.run_server()


checkpoint =""

block = Blockchain() 
thrd = threading.Thread(target = hi, args={})
thrd.start()
app.exec_()
